package cn.bunny.dao.dto.financial.savingGoal;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.time.LocalDate;

@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
@Schema(name = "SavingGoalDto对象", title = "用户储值查询", description = "用户储值查询")
public class SavingGoalDto {

    @Schema(name = "userId", title = "绑定的用户id")
    private Long userId;

    @Schema(name = "statusType", title = "完成状态")
    private String statusType;

    @Schema(name = "savingGoalName", title = "储值目标名称")
    private String savingGoalName;

    @Schema(name = "amount", title = "目标金额")
    private BigDecimal amount;

    @Schema(name = "startDuration", title = "开始目标时长")
    @JsonFormat(locale = "zh", timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private LocalDate startDuration;

    @Schema(name = "endDuration", title = "结束目标时长")
    @JsonFormat(locale = "zh", timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private LocalDate endDuration;

}
